unit UPuzzle;

interface

uses
  SysUtils, StrUtils,
  UCube,
  UPiece;

type
  TPuzzle = class(TObject)
  private
    FCoords: TCubeList;
  public
    constructor Create;
    destructor Destroy;

    function LoadFromFile(aFilename: string): boolean;

    property Coords: TCubeList read FCoords write FCoords;
  end;

implementation

//-----------------------------------------------------------------------------------------------------------------------
constructor TPuzzle.Create;
begin
  inherited Create;

  FCoords:= TCubeList.Create;
end;

//-----------------------------------------------------------------------------------------------------------------------
destructor TPuzzle.Destroy();
begin
  FreeAndNil(FCoords);

  inherited Destroy;
end;

//-----------------------------------------------------------------------------------------------------------------------
function TPuzzle.LoadFromFile(aFilename: string): boolean;
var
  aFile: TextFile;
  aCube: TCube;
//  pos1, pos2: integer;
  str: string;
  x, y, z: Byte;
begin
  result:= true;
  FCoords.Clear;

  try
    try
      AssignFile(aFile, aFileName);
      Reset(aFile);

      while not Eof(aFile) do
      begin
        ReadLn(aFile, str);

        if (str = '') then
          Break;                //Dans le cas de lignes vides aprs les coordonnes

        //Coordonnes pas de 0  9
        {
        pos1:= PosEx(',', str);
        pos2:= PosEx(',', str, pos1+1);

        x:= StrToInt(Trim(LeftStr(str, pos1-1)));
        y:= StrToInt(Trim(MidStr(str, pos1+1, pos2 - pos1 - 1 )));
        z:= StrToInt(Trim(RightStr(str, length(str) - pos2)));
        aCube:= TCube.Create(x, y, z);
        }

        //Coordonnes de 0  9
        x:= StrToInt(str[1]);
        y:= StrToInt(str[3]);
        z:= StrToInt(str[5]);
        aCube:= TCube.Create(x, y, z);

        if ( FCoords.IsInList(aCube) = -1) then
          FCoords.Add(aCube);
      end;

    except
      result:= false;
    end;

  finally
    CloseFile(aFile);

  end;


  FCoords.SortByMin;

end;


end.
